org.openstreetmap.josm.plugins.streetside.utils

## Class CubemapBox

- java.lang.Object
- - javafx.scene.Node
  - - javafx.scene.Parent
    - - javafx.scene.Group
      - - org.openstreetmap.josm.plugins.streetside.utils.CubemapBox

- All Implemented Interfaces:
    javafx.css.Styleable, javafx.event.EventTarget

      public class CubemapBox
      extends javafx.scene.Group

- - ### Property Summary

    All Methods Instance Methods Concrete Methods
    Type | Property and Description
    --- | ---
    `javafx.beans.property.DoubleProperty` | `size`

    - ### Properties inherited from class javafx.scene.Group

      `autoSizeChildrenProperty`

    - ### Properties inherited from class javafx.scene.Parent

      `impl_traversalEngineProperty, needsLayoutProperty`

    - ### Properties inherited from class javafx.scene.Node

      `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, cacheHintProperty, cacheProperty, clipProperty, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, focusedProperty, focusTraversableProperty, hoverProperty, idProperty, impl_showMnemonicsProperty, impl_treeVisibleProperty, inputMethodRequestsProperty, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParentTransformProperty, localToSceneTransformProperty, managedProperty, mouseTransparentProperty, nodeOrientationProperty, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, pickOnBoundsProperty, pressedProperty, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, styleProperty, translateXProperty, translateYProperty, translateZProperty, visibleProperty`

  - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `CubemapBox.CubemapBoxImageType`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private javafx.scene.transform.Affine` | `affine`
    `private javafx.scene.image.ImageView` | `back`
    `private javafx.scene.image.Image` | `backImg`
    `private javafx.scene.PerspectiveCamera` | `camera`
    `private javafx.scene.image.ImageView` | `down`
    `private javafx.scene.image.Image` | `downImg`
    `private javafx.scene.image.ImageView` | `front`
    `private javafx.scene.image.Image` | `frontImg`
    `private CubemapBox.CubemapBoxImageType` | `imageType`
    `private javafx.scene.image.ImageView` | `left`
    `private javafx.scene.image.Image` | `leftImg`
    `private javafx.scene.image.ImageView` | `right`
    `private javafx.scene.image.Image` | `rightImg`
    `private javafx.scene.image.Image` | `singleImg`
    `private javafx.beans.property.DoubleProperty` | `size`
    `private javafx.animation.AnimationTimer` | `timer`
    `private javafx.scene.image.ImageView` | `up`
    `private javafx.scene.image.Image` | `upImg`
    `private javafx.scene.image.ImageView[]` | `views`

    - ### Fields inherited from class javafx.scene.Node

      `BASELINE_OFFSET_SAME_AS_HEIGHT`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CubemapBox(double size, javafx.scene.PerspectiveCamera camera)`
    `CubemapBox(javafx.scene.image.Image singleImg, double size, javafx.scene.PerspectiveCamera camera)`
    `CubemapBox(javafx.scene.image.Image frontImg, javafx.scene.image.Image rightImg, javafx.scene.image.Image backImg, javafx.scene.image.Image leftImg, javafx.scene.image.Image upImg, javafx.scene.image.Image downImg, double size, javafx.scene.PerspectiveCamera camera)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `getSize()` Gets the value of the property size.
    `javafx.scene.image.ImageView[]` | `getViews()`
    `private void` | `layoutViews()`
    `void` | `loadImageViews()`
    `private void` | `loadSingleImageViewports()` 01-front, 02-right, 03-back, 10-left, 11-up, 12-down ____ ____ ____ ____ ____ ____ |fwd |rght|back|left|top |bot | |____|____|____|____|____|____|
    `private void` | `recalculateSize(double cell)`
    `void` | `setImage(BufferedImage img, int position)`
    `private void` | `setMultipleImages()`
    `void` | `setSize(double value)` Sets the value of the property size.
    `javafx.beans.property.DoubleProperty` | `sizeProperty()`
    `void` | `startTimer()`
    `private void` | `validateImageType()` for single image creates viewports and sets all views(image) to singleImg for multiple...

    - ### Methods inherited from class javafx.scene.Group

      `autoSizeChildrenProperty, getChildren, impl_computeLayoutBounds, isAutoSizeChildren, layoutChildren, minHeight, minWidth, prefHeight, prefWidth, setAutoSizeChildren`

    - ### Methods inherited from class javafx.scene.Parent

      `computeMinHeight, computeMinWidth, computePrefHeight, computePrefWidth, getBaselineOffset, getChildrenUnmodifiable, getImpl_traversalEngine, getManagedChildren, getStylesheets, impl_computeContains, impl_computeGeomBounds, impl_createPeer, impl_getAllParentStylesheets, impl_pickNodeLocal, impl_processCSS, impl_processMXNode, impl_traversalEngineProperty, impl_updatePeer, isNeedsLayout, layout, lookup, needsLayoutProperty, queryAccessibleAttribute, requestLayout, requestParentLayout, setImpl_traversalEngine, setNeedsLayout, updateBounds`

    - ### Methods inherited from class javafx.scene.Node

      `accessibleHelpProperty, accessibleRoleDescriptionProperty, accessibleRoleProperty, accessibleTextProperty, addEventFilter, addEventHandler, applyCss, autosize, blendModeProperty, boundsInLocalProperty, boundsInParentProperty, buildEventDispatchChain, cacheHintProperty, cacheProperty, clipProperty, computeAreaInScreen, contains, contains, containsBounds, cursorProperty, depthTestProperty, disabledProperty, disableProperty, effectiveNodeOrientationProperty, effectProperty, eventDispatcherProperty, executeAccessibleAction, fireEvent, focusedProperty, focusTraversableProperty, getAccessibleHelp, getAccessibleRole, getAccessibleRoleDescription, getAccessibleText, getBlendMode, getBoundsInLocal, getBoundsInParent, getCacheHint, getClassCssMetaData, getClip, getContentBias, getCssMetaData, getCursor, getDepthTest, getEffect, getEffectiveNodeOrientation, getEventDispatcher, getId, getInputMethodRequests, getLayoutBounds, getLayoutX, getLayoutY, getLocalToParentTransform, getLocalToSceneTransform, getNodeOrientation, getOnContextMenuRequested, getOnDragDetected, getOnDragDone, getOnDragDropped, getOnDragEntered, getOnDragExited, getOnDragOver, getOnInputMethodTextChanged, getOnKeyPressed, getOnKeyReleased, getOnKeyTyped, getOnMouseClicked, getOnMouseDragEntered, getOnMouseDragExited, getOnMouseDragged, getOnMouseDragOver, getOnMouseDragReleased, getOnMouseEntered, getOnMouseExited, getOnMouseMoved, getOnMousePressed, getOnMouseReleased, getOnRotate, getOnRotationFinished, getOnRotationStarted, getOnScroll, getOnScrollFinished, getOnScrollStarted, getOnSwipeDown, getOnSwipeLeft, getOnSwipeRight, getOnSwipeUp, getOnTouchMoved, getOnTouchPressed, getOnTouchReleased, getOnTouchStationary, getOnZoom, getOnZoomFinished, getOnZoomStarted, getOpacity, getParent, getProperties, getPseudoClassStates, getRotate, getRotationAxis, getScaleX, getScaleY, getScaleZ, getScene, getStyle, getStyleableParent, getStyleClass, getTransforms, getTranslateX, getTranslateY, getTranslateZ, getTypeSelector, getUserData, hasProperties, hoverProperty, idProperty, impl_clearDirty, impl_computeIntersects, impl_cssGetCursorInitialValue, impl_cssGetFocusTraversableInitialValue, impl_findStyles, impl_geomChanged, impl_getLeafTransform, impl_getMatchingStyles, impl_getPeer, impl_getPivotX, impl_getPivotY, impl_getPivotZ, impl_getStyleMap, impl_hasTransforms, impl_intersects, impl_intersectsBounds, impl_isDirty, impl_isDirtyEmpty, impl_isShowMnemonics, impl_isTreeVisible, impl_layoutBoundsChanged, impl_markDirty, impl_notifyLayoutBoundsChanged, impl_pickNode, impl_processCSS, impl_reapplyCSS, impl_setShowMnemonics, impl_setStyleMap, impl_showMnemonicsProperty, impl_syncPeer, impl_transformsChanged, impl_traverse, impl_treeVisibleProperty, inputMethodRequestsProperty, intersects, intersects, isCache, isDisable, isDisabled, isFocused, isFocusTraversable, isHover, isManaged, isMouseTransparent, isPickOnBounds, isPressed, isResizable, isVisible, layoutBoundsProperty, layoutXProperty, layoutYProperty, localToParent, localToParent, localToParent, localToParent, localToParent, localToParentTransformProperty, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToScene, localToSceneTransformProperty, localToScreen, localToScreen, localToScreen, localToScreen, localToScreen, lookupAll, managedProperty, maxHeight, maxWidth, mouseTransparentProperty, nodeOrientationProperty, notifyAccessibleAttributeChanged, onContextMenuRequestedProperty, onDragDetectedProperty, onDragDoneProperty, onDragDroppedProperty, onDragEnteredProperty, onDragExitedProperty, onDragOverProperty, onInputMethodTextChangedProperty, onKeyPressedProperty, onKeyReleasedProperty, onKeyTypedProperty, onMouseClickedProperty, onMouseDragEnteredProperty, onMouseDragExitedProperty, onMouseDraggedProperty, onMouseDragOverProperty, onMouseDragReleasedProperty, onMouseEnteredProperty, onMouseExitedProperty, onMouseMovedProperty, onMousePressedProperty, onMouseReleasedProperty, onRotateProperty, onRotationFinishedProperty, onRotationStartedProperty, onScrollFinishedProperty, onScrollProperty, onScrollStartedProperty, onSwipeDownProperty, onSwipeLeftProperty, onSwipeRightProperty, onSwipeUpProperty, onTouchMovedProperty, onTouchPressedProperty, onTouchReleasedProperty, onTouchStationaryProperty, onZoomFinishedProperty, onZoomProperty, onZoomStartedProperty, opacityProperty, parentProperty, parentToLocal, parentToLocal, parentToLocal, parentToLocal, parentToLocal, pickOnBoundsProperty, pressedProperty, pseudoClassStateChanged, relocate, removeEventFilter, removeEventHandler, requestFocus, resize, resizeRelocate, rotateProperty, rotationAxisProperty, scaleXProperty, scaleYProperty, scaleZProperty, sceneProperty, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, sceneToLocal, screenToLocal, screenToLocal, screenToLocal, setAccessibleHelp, setAccessibleRole, setAccessibleRoleDescription, setAccessibleText, setBlendMode, setCache, setCacheHint, setClip, setCursor, setDepthTest, setDisable, setDisabled, setEffect, setEventDispatcher, setEventHandler, setFocused, setFocusTraversable, setHover, setId, setInputMethodRequests, setLayoutX, setLayoutY, setManaged, setMouseTransparent, setNodeOrientation, setOnContextMenuRequested, setOnDragDetected, setOnDragDone, setOnDragDropped, setOnDragEntered, setOnDragExited, setOnDragOver, setOnInputMethodTextChanged, setOnKeyPressed, setOnKeyReleased, setOnKeyTyped, setOnMouseClicked, setOnMouseDragEntered, setOnMouseDragExited, setOnMouseDragged, setOnMouseDragOver, setOnMouseDragReleased, setOnMouseEntered, setOnMouseExited, setOnMouseMoved, setOnMousePressed, setOnMouseReleased, setOnRotate, setOnRotationFinished, setOnRotationStarted, setOnScroll, setOnScrollFinished, setOnScrollStarted, setOnSwipeDown, setOnSwipeLeft, setOnSwipeRight, setOnSwipeUp, setOnTouchMoved, setOnTouchPressed, setOnTouchReleased, setOnTouchStationary, setOnZoom, setOnZoomFinished, setOnZoomStarted, setOpacity, setPickOnBounds, setPressed, setRotate, setRotationAxis, setScaleX, setScaleY, setScaleZ, setStyle, setTranslateX, setTranslateY, setTranslateZ, setUserData, setVisible, snapshot, snapshot, startDragAndDrop, startFullDrag, styleProperty, toBack, toFront, toString, translateXProperty, translateYProperty, translateZProperty, usesMirroring, visibleProperty`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Property Detail

    - #### size

          public javafx.beans.property.DoubleProperty sizeProperty

      See Also:
        `getSize()`, `setSize(double)`

  - ### Field Detail

    - #### affine

          private final javafx.scene.transform.Affine affine

    - #### front

          private final javafx.scene.image.ImageView front

    - #### right

          private final javafx.scene.image.ImageView right

    - #### back

          private final javafx.scene.image.ImageView back

    - #### left

          private final javafx.scene.image.ImageView left

    - #### up

          private final javafx.scene.image.ImageView up

    - #### down

          private final javafx.scene.image.ImageView down

    - #### views

          private final javafx.scene.image.ImageView[] views

    - #### frontImg

          private javafx.scene.image.Image frontImg

    - #### rightImg

          private javafx.scene.image.Image rightImg

    - #### backImg

          private javafx.scene.image.Image backImg

    - #### leftImg

          private javafx.scene.image.Image leftImg

    - #### upImg

          private javafx.scene.image.Image upImg

    - #### downImg

          private javafx.scene.image.Image downImg

    - #### singleImg

          private javafx.scene.image.Image singleImg

    - #### camera

          private final javafx.scene.PerspectiveCamera camera

    - #### timer

          private javafx.animation.AnimationTimer timer

    - #### imageType

          private final CubemapBox.CubemapBoxImageType imageType

    - #### size

          private final javafx.beans.property.DoubleProperty size

  - ### Constructor Detail

    - #### CubemapBox

          public CubemapBox(javafx.scene.image.Image singleImg,
                            double size,
                            javafx.scene.PerspectiveCamera camera)

    - #### CubemapBox

          public CubemapBox(double size,
                            javafx.scene.PerspectiveCamera camera)

    - #### CubemapBox

          public CubemapBox(javafx.scene.image.Image frontImg,
                            javafx.scene.image.Image rightImg,
                            javafx.scene.image.Image backImg,
                            javafx.scene.image.Image leftImg,
                            javafx.scene.image.Image upImg,
                            javafx.scene.image.Image downImg,
                            double size,
                            javafx.scene.PerspectiveCamera camera)

  - ### Method Detail

    - #### loadImageViews

          public void loadImageViews()

    - #### layoutViews

          private void layoutViews()

    - #### validateImageType

          private void validateImageType()

      for single image creates viewports and sets all views(image) to singleImg for multiple... sets images per view.

    - #### loadSingleImageViewports

          private void loadSingleImageViewports()

      01-front, 02-right, 03-back, 10-left, 11-up, 12-down ____ ____ ____ ____ ____ ____ |fwd |rght|back|left|top |bot | |____|____|____|____|____|____|

    - #### recalculateSize

          private void recalculateSize(double cell)

    - #### setImage

          public void setImage(BufferedImage img,
                               int position)

    - #### setMultipleImages

          private void setMultipleImages()

    - #### startTimer

          public void startTimer()

    - #### getSize

          public final double getSize()

      Gets the value of the property size.

    - #### setSize

          public final void setSize(double value)

      Sets the value of the property size.

    - #### sizeProperty

          public javafx.beans.property.DoubleProperty sizeProperty()

      See Also:
        `getSize()`, `setSize(double)`

    - #### getViews

          public javafx.scene.image.ImageView[] getViews()

JOSM Plugins